SystemOrganization addCategory: #'Khami-Web'!

WAFileLibrary subclass: #KmResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmResources methodsFor: 'css' stamp: 'StuartHerring 1/31/2011 00:00'!
styleCss
^'html {
	background: lightblue;
}

.summary {
	float: right;
	background: lightgray;
	padding: 0.5em;
	border: 1px solid black;
	margin: 0;
}

.summary dt {
	float: left;
	clear: left;
	font-weight: bold;
	width: 4em;
}

.summary dd {
	float: left;
	margin-left: 0.5em;
}

ul.menu { 
	padding: 0;
	margin-top: 0;
	background: gray;
}

.menu li {
	display: inline;
	padding-left: 3px;
	padding-right: 3px;
	margin: 0;
}

.menu li:hover {
	background: lightgray;
}
.menu li a {
text-decoration: none;
	color: white;
	margin: 0;
}

.menu li a:hover {
	color: gray;
}

table.gameBoard {
	border-collapse: collapse;
	border-color: gray;
	padding: 0;
}

table.gameBoard td {
	width: 52px;
	height: 52px;
	padding: 0px;
}

table.gameBoard td.available {
	background-color: white;
}

table.gameBoard td.available:hover {
	background-color: lightgrey;
}

table.gameBoard td.available a {
	display: block;
	margin: 0;
	height: 100%;
	width: 100%
	text-decoration: none;
}

table.KmTile {
	display: inline-block;
	border: 1px black solid;
	padding: 0;
	border-spacing: 0;
	margin-bottom: -4px;
}

table.KmTile td {
	width: 10px;
	height: 10px;
	background-color:lightgrey;
	padding: 0;
}


.KmTile td.KmFarmRegion {
	background: green;
}
.KmTile td.KmFarmRegionC {
	background: lightgreen;
}
.KmTile td.KmVillageRegion {
	background: brown;
}
.KmTile td.KmVillageRegionC {
	background: red;
}

.KmTile td.KmRoadPath {
	background: white;
}
.KmTile td.KmRoadPathC {
	background: black;
}
'! !

WAComponent subclass: #KmGameBoardComponent
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameBoardComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:28'!
for: aGame
	^self basicNew
		initializeWithGame: aGame;
		yourself! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:48'!
at: row at: column
	^game board at: row at: column! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:48'!
columns 
	^game board columns! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:45'!
initializeWithGame: aGame
	self initialize.
	game:= aGame! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:50'!
placeTileAt: row at: column
	game placeTileAt: row at: column! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 09:58'!
renderAvailableSpotFor: row at: column on: html
	html tableData class: #available; with: [
		html anchor callback: [ self placeTileAt: row at: column];
		with: [html space]]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 09:54'!
renderBlankSpotOn: html
	html tableData: [html space]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2011 12:42'!
renderContentOn: html.
	html table border: 1; class: 'gameBoard';with: [
		1 to: self rows do: [ :r |
			html tableRow: [
				1 to: self columns do: [ :c |
					self renderTileAt: r at: c on: html]]]]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:42'!
renderOccupiedSpotFor: aTile on: html
	html tableData: [
		html render: (KmTileRenderable for: aTile)]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 20:25'!
renderTileAt: row at: column on: html
	(self tileIsValidAt: row at: column)
		ifTrue: [self renderAvailableSpotFor: row at: column on: html]
		ifFalse: [ | tile |
			tile := self at: row at: column.
			tile isNil 
				ifTrue: [self renderBlankSpotOn: html]
				ifFalse: [self renderOccupiedSpotFor: tile on: html]]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:48'!
rows
	^game board rows! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 22:49'!
tileIsValidAt: row at: column
	| regions gameBoard |
	game currentTile ifNil: [^false].
	gameBoard := game board.
	^gameBoard canPlaceTile: game currentTile at: row at: column.! !

WAComponent subclass: #KmHome
	instanceVariableNames: 'gameBoard summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmHome class methodsFor: 'testing' stamp: 'StuartHerring 1/7/2011 14:42'!
canBeRoot
	^true! !

!KmHome class methodsFor: 'testing' stamp: 'StuartHerring 1/15/2011 16:30'!
initialize
	| app |
	WAAdmin register: self asApplicationAt: 'vok'.
	WADispatcher default defaultName: 'vok'.
	app := WADispatcher default defaultHandler.
	app preferenceAt: #sessionClass put: KmSession ! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:15'!
children
	^Array with: gameBoard with: summary.! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 23:15'!
initialize
	super initialize.
	gameBoard := KmGameBoardComponent for: self session game.
	summary := KmTerritorySummary new.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:26'!
renderContentOn: html
	self renderMenuOn: html.
	html render: summary.
	self session currentTile ifNotNil: [ html render: (KmTileRenderable for: self session currentTile)].
	self renderGameBoardOn: html.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/12/2011 12:08'!
renderGameBoardOn: html
	html render: gameBoard! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:37'!
renderMenuItem: text do: aBlock on: html
	html listItem: [html anchor callback: aBlock; with: text ]! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:57'!
renderMenuOn: html
	| currentTile |
	currentTile := self session currentTile.
	html unorderedList 
		class: #menu;
		with: [
			self renderMenuItem: 'Show Remaining Tiles' do: [ self showRemaining ] on: html.
			self renderMenuItem: 'Show Territory Info' do: [self showTerritories] on: html.
			((self session game remainingTiles size > 0) and: [ currentTile isNil])
				ifTrue: [ self renderMenuItem: 'Take tile' do: [self takeTile ] on: html].
			currentTile ifNotNil: [ self renderMenuItem: 'Rotate Tile' do: [self rotateTile] on: html ]]! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/18/2011 19:42'!
rotateTile
	self session currentTile rotate! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/9/2011 18:32'!
showRemaining
	self call: KmTileList new.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:57'!
showTerritories
	self call: KmTerritoryInfo new.! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 10:55'!
takeTile
	self session game takeTile! !

!KmHome methodsFor: 'updating' stamp: 'StuartHerring 1/9/2011 08:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WAComponent subclass: #KmTerritoryInfo
	instanceVariableNames: 'summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritoryInfo methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 23:14'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html heading level: 2; with: 'Territory Information'.
	html render: summary.
	html anchor callback: [ self answer]; with: 'Close'.! !

!KmTerritoryInfo methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 23:42'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WAComponent subclass: #KmTerritorySummary
	instanceVariableNames: 'summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritorySummary methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 23:46'!
render: aCollection named: aString on: html
	html definitionTerm: aString.
	html definitionData: [
		html render: aCollection size;
			render: ' (';
			render: (aCollection select: [ :t | t isComplete ]) size;
			render: ')']! !

!KmTerritorySummary methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 00:02'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html definitionList class: #summary; with: [ 
		self render: (territories select: [ :t | t type = #road]) named: 'Roads' on: html.
		self render: (territories select: [ :t | t type = #farm]) named: 'Farms' on: html.
		self render: (territories select: [ :t | t type = #village]) named: 'Villages' on: html.
		self render: territories  named: 'Total' on: html.
	].
! !

WAComponent subclass: #KmTileList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileList class methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 18:25'!
canBeRoot
	^true! !

!KmTileList methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 12:10'!
initialize
	super initialize.! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 12:12'!
renderContentOn: html
	html heading level: 2; with: 'Tiles Remaining'.	
	self session game remainingTiles do: [ :t |
		html render: (KmTileRenderable for: t)
	].
	html break.
	html anchor callback: [ self answer ]; with: 'Close'
! !

!KmTileList methodsFor: 'updating' stamp: 'StuartHerring 1/9/2011 18:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WASession subclass: #KmSession
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2011 19:42'!
currentTile
	^game currentTile! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:28'!
game
	^game! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initialize
	super initialize.
	self initializeGame.! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initializeGame
	game := KmGame testGame.! !

Object subclass: #KmTileRenderable
	instanceVariableNames: 'tile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileRenderable class methodsFor: 'instance creation' stamp: 'StuartHerring 1/13/2011 19:40'!
for: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:17'!
classFor: aRegion
	^String streamContents: [ :s |
		s nextPutAll: aRegion class	name.
		aRegion isComplete ifTrue: [s nextPut: $C]]! !

!KmTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2011 17:10'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/19/2011 01:11'!
renderBlankOn: html
	html tableData! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/19/2011 01:11'!
renderCornerOn: html
	html tableData.! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:09'!
renderHorizontalPathAt: side on: html
	html tableData 
			colSpan: 2;
			class: (self classFor: (tile at: side))! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/28/2011 20:31'!
renderOn: html
	html table class: (KmTile class name); with: [
		html tableRow: [
			self renderRegionOrBlankAt: LeftTop on: html.
			self renderRegion: (tile at: TopLeft) on: html.
			self renderVerticalPathAt: Top on: html.
			self renderRegion: (tile at: TopRight) on: html.
			self renderRegionOrBlankAt: TopRight on: html.
		].
		html tableRow: [ 
			self renderRegion: (tile at: LeftTop) on: html.
			self renderRegionOrBlankAt: LeftTop on: html.
			self renderRegionOrBlankAt: TopRight on: html.
			self renderRegion: (tile at: RightTop) on: html.
		].
		html tableRow: [
			self renderHorizontalPathAt: Left on: html.
			self renderPath: (tile at: Centre) on: html.
			self renderHorizontalPathAt: Right on: html
			].
		html tableRow: [ 
			self renderRegion: (tile at: LeftBottom) on: html.
			self renderRegionOrBlankAt: BottomLeft on: html.
			self renderVerticalPathAt: Bottom on: html.
			self renderRegionOrBlankAt: RightBottom on: html.
			self renderRegion: (tile at: RightBottom) on: html.
		].
		html tableRow: [
			self renderRegionOrBlankAt: BottomLeft on: html.
			self renderRegion: (tile at: BottomLeft) on: html.
			self renderRegion: (tile at: BottomRight) on: html.
			self renderRegionOrBlankAt: RightBottom on: html.
		]
	]	
! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:10'!
renderPath: aPath on: html
	html tableData 
		class: (self classFor: aPath)! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:10'!
renderRegion: aRegion on: html
	html tableData 
		class: (self classFor: aRegion)! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:11'!
renderRegionOrBlankAt: region on: html.
	(tile at: region) class = (tile at: region connectingLocations first) class
		ifTrue: [self renderRegion: (tile at: region) on: html]
		ifFalse: [ self renderBlankOn: html]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:18'!
renderVerticalPathAt: side on: html
	html tableData 
			rowSpan: 2;
			class: (self classFor: (tile at: side))! !
KmHome initialize!
